package apap.tutorial.belajarbelajar.service;


import apap.tutorial.belajarbelajar.model.CourseModel;
import apap.tutorial.belajarbelajar.repository.CourseDb;
import com.sun.jdi.connect.ListeningConnector;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Optional;

@Service
@Transactional
public class CourseServiceImpl implements CourseService {
    @Autowired
    CourseDb courseDb;

    @Override
    public void addCourse(CourseModel course){
        courseDb.save(course);
    }

    @Override
    public List<CourseModel> getListCourse(){
        return courseDb.findAll();
    }

    @Override
    public CourseModel getCourseByCodeCourse(String code) {
        Optional<CourseModel> course = courseDb.findByCode(code);
        if (course.isPresent()) {
            return course.get();
        } else return null;
    }

    @Override
    public CourseModel getCourseOrderByName() {
        Optional<CourseModel> course = courseDb.findAllByOrderByNameCourse();
        if (course.isPresent()) {
            return course.get();
        } else return null;
    }

    @Override
    public CourseModel getCourseByCodeCourseQuery(String code) {
        Optional<CourseModel> course = courseDb.findByCodeUsingQuery(code);
        if (course.isPresent()) {
            return course.get();
        } else return null;
    }

    @Override
    public CourseModel updateCourse(CourseModel course) {
        courseDb.save(course);
        return course;
    }

    @Override
    public List<CourseModel> getListCourseOrderByNameCourse() {
        List<CourseModel> ListCourseOrderByNameCourse = courseDb.findAllCourseSorted();
        return ListCourseOrderByNameCourse;
    }

    @Override
    public boolean updateSksByCode(String code, int jumlahSks) {
        return false;
    }

    @Override
    public boolean deleteCourseByCode(String code) {
        return false;
    }

    @Override
    public boolean cantAddCourseWithSameCode(String code) {
        return false;
    }

    @Override
    public boolean deleteCourseWithSameSks(int jumlahSks) {
        return false;
    }

    @Override
    public boolean deleteCourse(CourseModel Course, LocalDateTime waktuBerakhir, LocalDateTime waktuMulai) {
        boolean isEnding = true;
        LocalDateTime now = LocalDateTime.now();

        if (now.isBefore(waktuBerakhir) && now.isAfter(waktuMulai)) {
            isEnding = false;
        }
        else {
            isEnding = true;
            courseDb.delete(Course);
        }
        return isEnding;
    }

    @Override
    public boolean compareDateTime(LocalDateTime waktuBerakhir, LocalDateTime waktuMulai) {
        boolean isEnding = true;
        LocalDateTime now = LocalDateTime.now();

        if (now.isBefore(waktuBerakhir) && now.isAfter(waktuMulai)) {
            isEnding = false;
        }
        return isEnding;
    }

    @Override
    public boolean isClosed(LocalDateTime tanggalDimulai, LocalDateTime tanggalBerakhir) {
        LocalDateTime now = LocalDateTime.now();
        if (now.isBefore(tanggalDimulai) || now.isAfter(tanggalBerakhir)) {
            return true;
        }
        return false;
    }
}